#include "..\Lib\8000A.h"
#include "..\Lib\8172.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>

int slot=-1;
int main(void)
{
	int i=0;
	int fr_module=0;
	int port = 0;
	int group = 0;
	int mode=0;
	short bitMode = 12;
	short typeCode = 0x08;  // -10 ~ +10 V
	short channel = 0;
	short jumper =0;
	short maxCh=8;
	float fval = 0.0F;
	short doval=0;
	for(i=0;i<8;i++){
		if(i8172_Init(i)==0){
			slot=i;
			break;
		}
	}
	if(i==-1){
		printf("There is no i8172W at Backplane\n");
		Getch();
		return 0;
	}
	else{
		printf("There is an i8172W at i %d\n",slot);
	}
	printf("Please select the FRnet module to be configure : \n");
	printf("0 : FR-2017\n");
	printf("1 : FR-2024\n");
	printf("2 : FR-2053\n");
	printf("3 : FR-2054\n");
	printf("4 : FR-2057\n");
	scanf("%d",&fr_module);
	printf("Please input the port number : \n");
	printf("For I-8172W => 0 ~ 1\n");
	scanf("%d",&port);
	printf("Please input the group index of FRnet module :\n");
	scanf("%d",&group);
	switch(fr_module){
		case 0:{
			printf("Please input jumper of FR-2017 Differential = 0 Single-Ended = 1 : \n");
			scanf("%d",&jumper);
			if(jumper ==0){
				maxCh=8 ; // default
			}
			else{
				maxCh=16;
			}
			printf("Please input bit mode of FR-2017 -> 12 for 12-bit; 16 for 16-bit \n");
			scanf("%d",&bitMode);
			printf("Please slect type code for FR-2017\n");
			printf("0x1a : 0 ~ 20 mA\n");
			printf("0x7  : 4 ~ 20 mA\n");
			printf("0x8  : +/-10 V\n");
			printf("0x9  : +/-5 V\n");
			printf("0xa  : +/-1 V\n");
			printf("0xb  : +/-500 mV\n");
			printf("0xc  : +/-150 mV \n");
			printf("0xd  : +/-20 mA\n");
			scanf("%d",&typeCode);
			if((0x1a != typeCode) && (typeCode < 7 || typeCode > 0xd)){
				typeCode = 0x08;  // -10 ~ +10 V
			}
			if(channel > 7 || channel < 0){  //differential mode
				channel = 0;
			}
			for(channel=0;channel<maxCh;channel++){
				i8172_ReadAI_Ch(slot,port,group,bitMode,typeCode,channel,&fval);
				printf("AI[%d] = %f\n",channel,fval);
			}
			break;
		}
		case 1:{
			printf("Please input bit mode:\n");
			printf("12 : 12-bit mode \n");
			printf("16 : 16-bit mode \n");
			scanf("%d",&bitMode);
			printf("Please input the number of output channel for i-8172W 0 ~ 3\n");
			scanf("%d",&channel);
			printf("Please slect type code for FR-2024\n");
			printf("0 or 0x30 : 0 ~ 20 mA\n");
			printf("1 or 0x31 : 4 ~ 20 mA\n");
			printf("2 or 0x32 : 0~10 V\n");
			printf("3 or 0x33 : +/-10V\n");
			printf("4 or 0x34 : +/-1 V\n");
			printf("5 or 0x35 : +/-5 V\n");
			scanf("%d",&typeCode);
			printf("Please input output value \n");
			scanf("%d",&fval);
			i8172_WriteAOFloat(slot,port,group,bitMode,channel,typeCode,fval,0);
			break;
		}
		case 2:{
			for(channel=0;channel<16;channel++){
				printf("CH[%d]= %d \n\r", channel,i8172_ReadDIBit(slot,port,group,channel));
			}
			break;
		}
		case 3:{
			printf("Please select operation mode:\n");
			printf("0 : Write Digital output \n");
			printf("1 : Read Digital input \n");
			scanf("%d",&mode);
			switch(mode){
				case 0:{
					printf("Please input DO value 0x00 ~ 0xff :\n");
					scanf("%X",&doval);
					i8172_DIO_WriteDOGroup(slot,port,group,doval&0xff);
					break;
				}
				case 1:{
					printf("DI : %X\n\r",i8172_DIO_ReadDIGroup(slot,port,group+8));
					break;
				}
			}
			break;
		}
		case 4:{
			printf("Please input DO value 0x0000 ~ 0xffff :\n");		           
            scanf("%X",&doval);
            i8172_WriteDOGroup(slot,port,group,doval&0xffff);
			break;
		}
	}
	Getch();
	return 0;
}